﻿using Leadtools.Codecs;
using Leadtools.Controls;
using Leadtools.Drawing;
using Leadtools.WinForms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AddImageViewer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _cancelLoading = false;

            _browser.UseDpi = true;
            _browser.ItemSpacingSize = new Size(10, 10);
            _browser.Codecs = new Leadtools.Codecs.RasterCodecs();


            LoadImages("..\\..\\resources");

            _browser.SelectedIndexChanged += new EventHandler(_browser_SelectedIndexChanged);

            _browser.EnableRubberBandSelection = false;

            ImageViewerAddRegionInteractiveMode RegionInteractiveMode = new ImageViewerAddRegionInteractiveMode();

            RegionInteractiveMode.Shape = ImageViewerRubberBandShape.Rectangle;

            RegionInteractiveMode.AutoRegionToFloater = false;

            RegionInteractiveMode.WorkOnBounds = true;

            RegionInteractiveMode.WorkCompleted += new EventHandler(RegionInteractiveMode_WorkCompleted);

            RegionInteractiveMode.IsEnabled = true;

            imageViewer1.InteractiveModes.Add(RegionInteractiveMode);
        }

        private void RegionInteractiveMode_WorkCompleted(object sender, EventArgs e)
        {
            Leadtools.LeadRect lr = this.imageViewer1.Floater.GetRegionBounds(null);
        }
        private string _currentFolder;
        private bool _cancelLoading;

        private void LoadImages(string imageDirectory)
        {
            _browser.BeginUpdate();
            if (_browser.IsLoadingThumbnails)
            {
                _browser.CancelLoadingThumbnails();
                while (_browser.IsLoadingThumbnails)
                {
                    Application.DoEvents();
                    System.Threading.Thread.Sleep(100);
                }
            }

            _browser.Items.Clear();

            _currentFolder = imageDirectory;

            _cancelLoading = false;
            _browser.LoadThumbnails(_currentFolder, "*.*", RasterThumbnailBrowserLoadFlags.AllDirectories);
            _browser.EndUpdate();
        }

        private void _browser_SelectedIndexChanged(object sender, EventArgs e)
        {
            RasterCodecs rcs=new RasterCodecs();

            this.imageViewer1.Image = rcs.Load(this._browser.SelectedItems[0].FileName);
        }
    }
}
